# coding: utf-8

"""
    Cloudsmith API

    The API to the Cloudsmith Service

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Distribution(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'self_url': 'str',
        'name': 'str',
        'format': 'str',
        'versions': 'list[DistributionVersions]',
        'format_url': 'str',
        'variants': 'str',
        'slug': 'str'
    }

    attribute_map = {
        'self_url': 'self_url',
        'name': 'name',
        'format': 'format',
        'versions': 'versions',
        'format_url': 'format_url',
        'variants': 'variants',
        'slug': 'slug'
    }

    def __init__(self, self_url=None, name=None, format=None, versions=None, format_url=None, variants=None, slug=None):
        """
        Distribution - a model defined in Swagger
        """

        self._self_url = None
        self._name = None
        self._format = None
        self._versions = None
        self._format_url = None
        self._variants = None
        self._slug = None

        if self_url is not None:
          self.self_url = self_url
        self.name = name
        if format is not None:
          self.format = format
        if versions is not None:
          self.versions = versions
        if format_url is not None:
          self.format_url = format_url
        if variants is not None:
          self.variants = variants
        if slug is not None:
          self.slug = slug

    @property
    def self_url(self):
        """
        Gets the self_url of this Distribution.
        

        :return: The self_url of this Distribution.
        :rtype: str
        """
        return self._self_url

    @self_url.setter
    def self_url(self, self_url):
        """
        Sets the self_url of this Distribution.
        

        :param self_url: The self_url of this Distribution.
        :type: str
        """

        self._self_url = self_url

    @property
    def name(self):
        """
        Gets the name of this Distribution.
        

        :return: The name of this Distribution.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Distribution.
        

        :param name: The name of this Distribution.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def format(self):
        """
        Gets the format of this Distribution.
        

        :return: The format of this Distribution.
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """
        Sets the format of this Distribution.
        

        :param format: The format of this Distribution.
        :type: str
        """

        self._format = format

    @property
    def versions(self):
        """
        Gets the versions of this Distribution.
        A list of the versions for this distribution

        :return: The versions of this Distribution.
        :rtype: list[DistributionVersions]
        """
        return self._versions

    @versions.setter
    def versions(self, versions):
        """
        Sets the versions of this Distribution.
        A list of the versions for this distribution

        :param versions: The versions of this Distribution.
        :type: list[DistributionVersions]
        """

        self._versions = versions

    @property
    def format_url(self):
        """
        Gets the format_url of this Distribution.
        

        :return: The format_url of this Distribution.
        :rtype: str
        """
        return self._format_url

    @format_url.setter
    def format_url(self, format_url):
        """
        Sets the format_url of this Distribution.
        

        :param format_url: The format_url of this Distribution.
        :type: str
        """

        self._format_url = format_url

    @property
    def variants(self):
        """
        Gets the variants of this Distribution.
        

        :return: The variants of this Distribution.
        :rtype: str
        """
        return self._variants

    @variants.setter
    def variants(self, variants):
        """
        Sets the variants of this Distribution.
        

        :param variants: The variants of this Distribution.
        :type: str
        """

        self._variants = variants

    @property
    def slug(self):
        """
        Gets the slug of this Distribution.
        The slug identifier for this distribution

        :return: The slug of this Distribution.
        :rtype: str
        """
        return self._slug

    @slug.setter
    def slug(self, slug):
        """
        Sets the slug of this Distribution.
        The slug identifier for this distribution

        :param slug: The slug of this Distribution.
        :type: str
        """

        self._slug = slug

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Distribution):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
